!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!  T m a g   Photometric Package
!  @(#) $Id: tmag_comp.prg,v 1.2 2002/08/19 04:36:45 ohainaut Exp $
!
! tmag.prg
! @@ tmag measurements Zero Extn Colr 
!      (B,V,R,I) for each
!
! meas.tbl contains the instrumental mangitude; created by MAGN/CIR
! columns: 	:MAGNITUDE 
!		:airm	(manually from the frame)
!		:filter (manually)
! output:	:stdmag 
!
!----------------------------------------------------------------------
defi/par p1 ? c "measurement table"
if "{p1}" .eq. "??" then
   $ head -11 $MID_WORK/tmag_comp.prg
   return
endif
defi/par p2 ? n "zeropt B,V,R,I"
defi/par p3 ? n "extn   B,V,R,I"
!defi/par p4 ? n "colr B,V,R,I"

defi/loc mes_len/i/1/1 0
defi/loc std_len/i/1/1 0
defi/loc w_l1/i/1/1 0
defi/loc w_l2/i/1/1 0
defi/loc w_c/c/1/8 " "
defi/loc w_c1/c/1/8 " "
defi/loc w_c2/c/1/8 " "
defi/loc w/r/1/2 0.,0.
defi/loc zpt/r/1/4 {p2}
defi/loc ext/r/1/4 {p3}
defi/loc col/r/1/4 0.,0.,0.,0. ! {p4}

@@ tmag_checkfile {p1} .tbl check
defi/loc intab/c/1/72 {outputc}


mes_len = {{intab},TBLCONTR(4)}

defi/loc i/i/1/1 0
defi/loc j/i/1/1 0
defi/loc filt/c/1/1 "-"
cre/col {intab} :stdmag ? F8.3 R*4

cre/col {intab} :extn ? F8.3 R*4
cre/col {intab} :zero ? F8.3 R*4
cre/col {intab} :colr ? F8.3 R*4

!scan the measurement table:
do i = 1 {mes_len}
  filt = "{{intab},:FILTER,@{i}}"
  if "{filt}" .eq. "B" then
	{intab},:extn,@{i} = {ext(1)} ! 0.214
	{intab},:zero,@{i} = {zpt(1)}
	{intab},:colr,@{i} = {col(1)}
	endif
  if "{filt}" .eq. "V" then
	{intab},:extn,@{i} = {ext(2)} ! 0.125
	{intab},:zero,@{i} = {zpt(2)}
	{intab},:colr,@{i} = {col(2)}
	endif
  if "{filt}" .eq. "R" then
	{intab},:extn,@{i} = {ext(3)} !0.091
	{intab},:zero,@{i} = {zpt(3)}
	{intab},:colr,@{i} = {col(3)}
	endif
  if "{filt}" .eq. "I" then
	{intab},:extn,@{i} = {ext(4)} ! 0.051
	{intab},:zero,@{i} = {zpt(4)}
	{intab},:colr,@{i} = {col(4)}
	endif
enddo

comp/tab {intab} :stdmag = :magnitude + :zero -:extn*:airm 

read/tab {intab} :ident :stdmag :filter
